 /* Copyright (c) 1994 by M.Lonnroth, Oracle Corp.  All Rights Reserved */

/***
   NAME
     oci
   PURPOSE
     OCI wrappers
   NOTES
     
   HISTORY
     mloennro - Oct 13, 1994: Created.
     $Log: oci.h,v $
 * Revision 1.1  1994/12/28  13:48:26  mloennro
 * Initial revision
 *
 * Revision 1.1  1994/10/17  20:53:13  mloennro
 * Initial revision
 *
***/

#ifndef OCI
#define OCI

#include <stdio.h>
#ifdef __STDC__
#include <ociapr.h>
#else
#include <ocidfn.h>
#include <ocikpr.h>
#endif

/* OCI type */
#define OCI_CHAR 1
#define OCI_CHARZ 97
#define OCI_INT 3
#define INTL sizeof(int)

#define ERR_USAGE 1
#define ERR_MALLOC 2
#define ERR_OCI 3
#define ERR_PIPE 4

#define RAISE_ERROR(x) wowFail(x)
#ifdef __STDC__
extern void wowFail(char *s);
#else
extern void wowFail();
#endif
typedef struct DB
{
     Lda_Def *lda;        /* Logon structure */
     ub1 hda[256];        /* host data */
} dbConnection;

#ifdef __STDC__
void dbErr (char *src, Lda_Def *lda, Cda_Def *cda);
void dbLogon (dbConnection *db,char *uid);
void dbLogoff (Lda_Def *lda);
Cda_Def *dbParse (Lda_Def *lda,char *sql);
void dbBind (Lda_Def *lda,Cda_Def *cda,text *sqlvar,text *progv,sb2 *indp);
void dbBindNum (Lda_Def *lda,Cda_Def *cda,text *sqlvar,int *progv,sb2 *indp);
void dbBindArr (Lda_Def *lda,Cda_Def *cda,text *sqlvar,ub4 arrsz,text **progv,
		ub2 *progl,sb2 *indp,ub2 *rcode,ub4 *retarr);
void dbExe (Lda_Def *lda,Cda_Def *cda);
void dbFinish (Lda_Def *lda);
void dbClose (Lda_Def *lda,Cda_Def *cda);
#else
void dbErr();
void dbLogon();
void dbLogoff();
Cda_Def *dbParse();
void dbBind();
void dbBindNum();
void dbBindArr();
void dbExe();
void dbFinish();
void dbClose();
#endif

#endif /* OCI */
